var cm = require("sdk/context-menu");
var panels = require("sdk/panel");
var selection = require("sdk/selection");
var self = require("sdk/self");
var sidebars = require("./sidebar");
var simpleprefs=require("sdk/simple-prefs");
var tabs = require("sdk/tabs");
var widgets = require("sdk/widget");
var _=require("sdk/l10n").get;

var selectedText;

function selectionChanged(event) {
  selectedText = selection.text;
}

selection.on("select", selectionChanged);

function openArticle() {
  console.log(selectedText);
  tabs.open("http://"+simpleprefs.prefs.language+".wikipedia.org/w/index.php?search=" + selectedText);
}

function openArticleInPanel(widgetView) {
  if(simpleprefs.prefs.use_panel) {
    panel.port.emit("loadPage", "http://"+simpleprefs.prefs.language+".m.wikipedia.org/w/index.php?search=" + selectedText);
    widgetView.panel=panel;
  } else {
    openArticle();
    widgetView.panel=null;
  }
}

cm.Item({
  label: _("getWikipediaArticle"),
  context: cm.SelectionContext(),
  contentScript: 'self.on("click", self.postMessage);',
  onMessage: openArticle
});

var panel = panels.Panel ({
  contentURL: self.data.url("panel.html"),
  contentScriptFile: self.data.url("panel.js"),
  onHide: function () {
    panel.port.emit("loadPage", "about:blank");
  },
  width: 450,
  heigth: 450
});

var panel = panels.Panel ({
  contentURL: self.data.url("panel.html"),
  contentScriptFile: self.data.url("panel.js"),
  onHide: function () {
    panel.port.emit("loadPage", "about:blank");
  },
  width: 450,
  heigth: 450
});

panel.port.on("closePanel", function() {
  panel.hide();
});

var sidebar = sidebars.sidebar({});

panel.port.on("toggleSidebar", function() {
  if(sidebar.instances[0].vbox.hidden) {
    sidebar = sidebars.sidebar ({
        url: "http://"+simpleprefs.prefs.language+".m.wikipedia.org/w/index.php?search=" + selectedText
    });
    sidebar.instances[0].vbox.width=300;
    sidebar.instances[0].show();
  } else {
    sidebar.instances[0].close();
  }
});

var widget = widgets.Widget({
  id: 'wikipedia-icon',
  label: 'Wikipedia',
  content: '<b style="font-family:Times">W</b>',
  panel: panel,
  onClick: openArticleInPanel
});
